'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var reactRouterDom = require('react-router-dom');
var react = require('react');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct.bind();
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;
  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;
    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);
      _cache.set(Class, Wrapper);
    }
    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };
  return _wrapNativeSuper(Class);
}
function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}
function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }
  return _arr;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var ScrollNavigatePathError = /*#__PURE__*/function (_Error) {
  _inherits(ScrollNavigatePathError, _Error);
  var _super = _createSuper(ScrollNavigatePathError);
  function ScrollNavigatePathError() {
    var _this;
    _classCallCheck(this, ScrollNavigatePathError);
    for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
      params[_key] = arguments[_key];
    }
    _this = _super.call(this, params);
    _this.name = "ScrollNavigatePathError";
    return _this;
  }
  return _createClass(ScrollNavigatePathError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
var ScrollNavigateLeftError = /*#__PURE__*/function (_Error2) {
  _inherits(ScrollNavigateLeftError, _Error2);
  var _super2 = _createSuper(ScrollNavigateLeftError);
  function ScrollNavigateLeftError() {
    var _this2;
    _classCallCheck(this, ScrollNavigateLeftError);
    for (var _len2 = arguments.length, parameters = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      parameters[_key2] = arguments[_key2];
    }
    _this2 = _super2.call(this, parameters);
    _this2.name = "ScrollNavigateLeftError";
    return _this2;
  }
  return _createClass(ScrollNavigateLeftError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
var ScrollNavigateTopError = /*#__PURE__*/function (_Error3) {
  _inherits(ScrollNavigateTopError, _Error3);
  var _super3 = _createSuper(ScrollNavigateTopError);
  function ScrollNavigateTopError() {
    var _this3;
    _classCallCheck(this, ScrollNavigateTopError);
    for (var _len3 = arguments.length, parameters = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      parameters[_key3] = arguments[_key3];
    }
    _this3 = _super3.call(this, parameters);
    _this3.name = "ScrollNavigateTopError";
    return _this3;
  }
  return _createClass(ScrollNavigateTopError);
}( /*#__PURE__*/_wrapNativeSuper(Error));

/**
 *
 *  React hook to redirect to a new page and scroll to somewhere on the page
 *  It scrolls to the top by default
 *
 * @param {number} top - The y position to scroll to from top - default = 0 - must be between 0 and 100
 * @param {number} left - The x position to scroll to from left - default = 0 - must be between 0 and 100
 * @param {string} path - The path to navigate to - default = /
 */
function useScrollNavigate() {
  var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '/';
  var top = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var left = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var navigate = reactRouterDom.useNavigate();
  var _useState = react.useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    scrollNavigateError = _useState2[0],
    setScrollNavigateError = _useState2[1];
  var scrollNavigate = react.useCallback(function () {
    var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '/';
    var top = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var left = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    if (typeof path != "string") {
      setScrollNavigateError(new ScrollNavigatePathError("Path is not a string"));
      return;
    }
    if (typeof top !== "number") {
      setScrollNavigateError(new ScrollNavigateTopError("Top is not a number"));
      return;
    }
    if (top > 100 || top < 0) {
      setScrollNavigateError(new ScrollNavigateLeftError("Top isn't between 0 and 100"));
    }
    if (typeof left !== "number") {
      setScrollNavigateError(new ScrollNavigateTopError("Left is not a number"));
      return;
    }
    if (left > 100 || left < 0) {
      setScrollNavigateError(new ScrollNavigateLeftError("Left isn't between 0 and 100"));
    }
    setScrollNavigateError(false);
    navigate(path);
    window.scroll({
      left: 0,
      top: 0,
      behavior: 'smooth'
    });
  }, [path, top, left, setScrollNavigateError]);
  return {
    scrollNavigate: scrollNavigate,
    scrollNavigateError: scrollNavigateError
  };
}

/** Scroll to a html ref */
var NavigateContext = react.createContext();
var NavigateContextProvider = function NavigateContextProvider(_ref) {
  var children = _ref.children;
  var navigate = reactRouterDom.useNavigate();
  var _useState3 = react.useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    navigationBeacon = _useState4[0],
    setNavigationBeacon = _useState4[1];
  var navigationRef = react.useRef();
  var navigateToRef = react.useCallback(function (path) {
    navigate(path);
    setNavigationBeacon(Symbol());
  }, [navigate, setNavigationBeacon]);
  var value = react.useMemo(function () {
  }, [navigationRef, navigateToRef]);
  react.useLayoutEffect(function () {
    if (navigationBeacon === false || navigationBeacon === null) return;
    if (navigationRef.current instanceof HTMLElement) {
      var _navigationRef$curren = navigationRef.current.getBoundingClientRect(),
        left = _navigationRef$curren.left,
        top = _navigationRef$curren.top;
      window.scroll({
        left: left,
        top: top,
        behavior: 'smooth'
      });
    }
    setNavigationBeacon(false);
  }, [navigationBeacon, navigationRef, setNavigationBeacon]);
  return NavigateContext.Provider({
    value: value
  }, children);
};
var useNavigationContext = function useNavigationContext() {
  return react.useContext(NavigateContext);
};

exports.NavigateContext = NavigateContext;
exports.NavigateContextProvider = NavigateContextProvider;
exports.ScrollNavigateLeftError = ScrollNavigateLeftError;
exports.ScrollNavigatePathError = ScrollNavigatePathError;
exports.ScrollNavigateTopError = ScrollNavigateTopError;
exports["default"] = useScrollNavigate;
exports.useNavigationContext = useNavigationContext;
